package sexpression

import recursion.TailCall

import recursion.TailCalls.done
import recursion.TailCalls.tailCall

@DisplayName("list")
open class Cons(open var first: SExpression, open var rest: SExpression) : SExpression() {

    override val isCons: Boolean
        get() = true

    override fun toString(): String {
        return toStringTailRecursive(StringBuilder("(")).invoke()
    }

    private fun toStringTailRecursive(leadingString: StringBuilder): TailCall<String> {
        leadingString.append(first.toString())

        if (rest.isNull)
            return done(leadingString.append(")").toString())
        else if (rest.isCons) {
            return tailCall { (rest as Cons).toStringTailRecursive(leadingString.append(" ")) }
        }

        return done(leadingString.append(" . " + rest.toString() + ")").toString())
    }
}
